59 Commits

Author SHA1 Message Date
v4n cb71852068 fix: prompts for install script 2025-03-19 20:25:44 +02:00
v4n 26031c0381 version 0.4.0 release 2025-03-19 20:20:12 +02:00
Daedalusspacegames 9c73be1cb7 fix: modify date syntax to enhance compatibility with alternate coreutils implementations, such as [uutils](https://github.com/uutils/coreutils) (#29) 2025-03-19 12:10:17 +02:00
v4n a8e94c19fb feat: command to change load order of mods (#27)
* progress

* progress

* feat: progress

* progress

* done, needs more testing, pr -> change all functions to require -n before specifying name -> v0.4 (reindex db)

* testing done
2025-03-18 16:18:48 +02:00
v4n 6b968172ea fix: updating now works properly 2025-03-10 21:42:55 +02:00
v4n b3bc91522f do not update 2025-03-10 21:14:37 +02:00
v4n a7936c90bd fix: stop latest update 2025-03-10 21:07:03 +02:00
v4n 4d1af7e4a0 feat: modpack-create can select individual mods (#26) 2025-03-10 21:01:06 +02:00
v4n 0eff8afe6b fix: turned code into fn 2025-03-08 00:38:04 +02:00
v4n 3593e32a7b fix: upgrade mods was overwriting files 2025-03-07 23:24:30 +02:00
v4n 797739ea7a fix: uninstall correctly reindexes (fix #21) 2025-03-07 22:57:14 +02:00
v4n df006a7430 fix: infite loop while enabling (#25) 2025-03-07 18:20:34 +02:00
v4n 344e4348d4 fix: non important sed error 2025-03-06 04:09:45 +02:00
v4n 719217d00b bump: version 2025-03-06 01:29:45 +02:00
v4n b1930811f9 fix: segfault from infinite recursion 2025-03-06 01:29:14 +02:00
v4n d1ca18b563 bump: downgrade because of seg fault 2025-03-06 00:59:58 +02:00
v4n 5d91190dbf fix: code cleanup 2025-03-06 00:12:59 +02:00
v4n 28122ee332 feat: list is now compact, added verbose option 2025-03-05 19:09:57 +02:00
v4n 56bb73784e fix: directory checking in wrong place 2025-03-02 15:38:07 +02:00
v4n 0d8f22a2d0 fix: variants fix 2025-02-21 17:15:35 +02:00
v4n 3c6238f8d2 fix: show variants better 2025-02-21 16:16:42 +02:00
v4n a031230117 fix: bash black magic 2025-02-21 16:06:20 +02:00
v4n 77ae53ffa7 fix: weird update bug 2025-02-21 14:03:49 +02:00
v4n c23c57e16c fix: weird update bug 2025-02-21 14:01:36 +02:00
v4n 898400e526 fix: whitespace in help msg 2025-02-21 13:48:50 +02:00
v4n c45f5860d8 bump: version 2025-02-21 13:44:18 +02:00
v4n 838c834cc2 feat: easily install multiple variants (#20)
* feat: easily install multiple variants

* fix: filter only dirs that have patches
2025-02-21 13:16:29 +02:00
v4n 7b8b2fda8f fix: console output, formatting 2025-02-21 12:46:46 +02:00
Catherine Guelque 0485b56df5 There is no need to install in the global path nor to use SUDO if the given path was writtable (#18)
* There's no need for sudo + Added warning if not in PATH

* fix: removed duplicated command call

---------

Co-authored-by: v4n <105587619+v4n00@users.noreply.github.com>
2025-02-17 18:07:54 +02:00
v4n d18a9cdccf fix: formatting 2025-02-06 20:13:45 +02:00
v4n c74f4a8a00 fix: whitespace, version bump for earlier commit 2025-02-06 20:12:27 +02:00
Matt Cavanagh 9f592e7ce2 feat: added .editorconfig to ensure consistency across IDEs and to prevent line ending oopsies (#17) 2025-02-06 19:47:37 +02:00
v4n 21b1822006 fix: uninstall correctly downgrades 2025-02-06 19:43:30 +02:00
v4n dbcc7d1e96 fix: CRLF -> LF 2025-02-06 03:34:33 +02:00
v4n 09c40aa25f bump: version 2025-02-05 23:32:50 +02:00
Matt Cavanagh 1a01034816 feat: added self update mechanism (#15)
* feat: Added self update mechanism

* fix: Formatting

* fix: Formatting again

* fix: Arghhh INDENTATION

* feat: Updated readme with new command

* feat: Added shortcut command

* feat: Added more detail to the readme

* feat: Removed the check for the last update file. It seems a bit pointless to delay checking for it, it's curling github so it's not like it's a DDOS concern, and it could be the tool is getting updated often, why delay their updates? It's also just a curl, it's very inexpensive.

* feat: Removed REPO_URL, it was unused

* feat: Reverted version testing change (oops)

* feat: checking for updates timed at 1 hour

* fix: info messages formatting

---------

Co-authored-by: v4n <105587619+v4n00@users.noreply.github.com>
2025-02-05 23:29:21 +02:00
v4n 83e2161456 code: removed unnecessary parameter passing 2025-02-05 17:09:15 +02:00
Luca Saalfeld a2b904caa2 feat: prevent the same mod from being installed multiple times (#14)
* prevent the same mod from being installed multiple times

* use flag instead of variable for exit check
2025-02-05 16:59:00 +02:00
v4n 9f622ca130 bump: version 2025-02-05 16:27:04 +02:00
v4n 0ab273977e fix: function return typo, trailing slashes removed from paths (#13) 2025-02-05 16:23:32 +02:00
Luca Saalfeld 388afe69b7 fix: bash date comparison (#12) 2025-02-05 15:22:10 +02:00
v4n 3f0305c741 feat: steam deck install 2025-02-03 02:08:50 +02:00
v4n 1a6a13a621 fix: enable/disable logic 2025-02-03 01:49:41 +02:00
Harsh Shandilya 23cb0646bf Use portable shebangs (#7)
* h2mm: use portable shebang

* install.sh: use portable shebang
2025-01-28 11:49:51 +02:00
v4n 6768cab391 fix: disabling/enabling correctly downgrades/upgrades 2025-01-27 00:10:44 +02:00
v4n 35902f1f8f fix: downgrade logic 2025-01-23 09:29:48 +02:00
v4n 55f382a8e5 Merge pull request #3 from v4n00/dev
Add modpack managing
2025-01-22 21:09:07 +02:00
v4n c1785b5323 feat: added modpack management 2025-01-22 21:07:20 +02:00
v4n 115e8acac3 Merge pull request #2 from v4n00/dev
Install mods in batches
2025-01-17 20:46:05 +02:00
v4n 8b06d76c31 fix: downgrade mod logic 2025-01-17 20:40:03 +02:00
v4n fc7ccc2f7c info: version bump 2025-01-17 17:42:04 +02:00
v4n f763d96797 docs: updated for multiple installs 2025-01-17 17:40:36 +02:00
v4n 83260e9961 feat: install multiple mods at once 2025-01-17 16:59:36 +02:00
v4n 36fc676ce0 Merge branch 'master' into dev 2025-01-17 11:55:58 +02:00
v4n 911a9b86ff compatibility: easier for WSL, read now accepts autocompletion 2025-01-17 11:41:18 +02:00
v4n f9c047078d docs: update, install timeout 2025-01-17 10:06:13 +02:00
v4n c80812476b docs: updated 2025-01-16 17:36:27 +02:00
v4n 740b0edd98 fix: docs for help, backup before upgrading script 2025-01-16 17:08:34 +02:00
v4n cc91661663 code: work on cleaner code 2025-01-16 14:57:43 +02:00
6 changed files with 1504 additions and 623 deletions
+6
View File
@@ -0,0 +1,6 @@
[*]
indent_style = tab
indent_size = 4
end_of_line = lf
insert_final_newline = true
trim_trailing_whitespace = true
+1
View File
@@ -3,3 +3,4 @@
!install.sh !install.sh
!README.md !README.md
!version !version
!.editorconfig
+81 -51
View File
@@ -1,33 +1,27 @@
# Helldivers 2 Mod Manager CLI # Helldivers 2 Mod Manager CLI
- [Helldivers 2 Mod Manager CLI](#helldivers-2-mod-manager-cli) Helldivers 2 Mod Manager CLI is a command line interface for managing Helldivers 2 mods. Since there is no Linux mod manager available and I like being a nerd by using CLI tools instead of GUIs, this project was born.
- [Installation](#installation)
- [Usage](#usage)
- [Available commands](#available-commands)
- [Basic usage](#basic-usage)
- [Install a mod](#install-a-mod)
- [Uninstall a mod](#uninstall-a-mod)
- [Enable/disable mods](#enabledisable-mods)
- [List installed mods](#list-installed-mods)
- [Advanced usage](#advanced-usage)
- [Shortcuts](#shortcuts)
- [Exporting and importing](#exporting-and-importing)
- [Resetting all installed mods](#resetting-all-installed-mods)
- [Database location and details](#database-location-and-details)
- [Contributing](#contributing)
- [Planned features](#planned-features)
Helldivers 2 Mod Manager CLI is a command line interface for managing Helldivers 2 mods. Since there is no mod manager GUI for Helldivers 2 on Linux yet, this small script aims to provide a simple way to manage mods on Linux. This script is complete, the version will always [remain at 0.x.x](https://0ver.org/)
## Installation ## Installation
To install/update Helldivers 2 Mod Manager CLI run the following command in your terminal: To install Helldivers 2 Mod Manager CLI run the following command in your terminal:
```bash ```bash
sh -c "$(curl -fsSL https://raw.githubusercontent.com/v4n00/h2mm-cli/refs/heads/master/install.sh)" bash -c "$(curl -fsSL https://raw.githubusercontent.com/v4n00/h2mm-cli/refs/heads/master/install.sh)"
``` ```
Running this script will require sudo permissions. **DO NOT TRUST** random scripts from the internet. If you want to review the script before running it, check out the mod repository for yourself. > [!CAUTION]
> Running this script will require sudo permissions. **DO NOT TRUST** random scripts from the internet. If you want to review the script before running it, check out the mod repository for yourself.
If for some reason, the installation command doesn't work you can:
1. Go to <https://raw.githubusercontent.com/v4n00/h2mm-cli/refs/heads/master/install.sh>
1. Right click -> Save page as...
1. Go to your downloads folders `cd ~/Downloads`
1. Give the script execution permissions `chmod +x install.sh`
1. Run the script `./install.sh`
## Usage ## Usage
@@ -39,42 +33,52 @@ h2mm
### Available commands ### Available commands
- `install` - Install a mod with files - `install` - Install a mod by the file provided (directory, zip, patch).
- `uninstall` - Uninstall a mod by name - `uninstall` - Uninstall a mod.
- `list` - List all installed mods - `list` - List all installed mods.
- `export <zip_name>` - Export installed mods to a zip file - `enable` - Enable a mod.
- `import <zip_name>` - Import mods from a zip file - `disable` - Disable a mod.
- `reset` - Reset all installed mods - `export` - Export installed mods to a zip file.
- `help` - Display the help message - `import` - Import mods from a zip file.
- `order` - Change load order for a mod.
- `modpack-create` - Create a modpack from the currently installed mods.
- `modpack-switch` - Switch to a modpack.
- `modpack-list` - List all installed modpacks.
- `modpack-delete` - Delete a modpack.
- `modpack-overwrite` - Overwrite a modpack.
- `modpack-reset` - Reset all installed modpacks.
- `update` - Update h2mm to latest version.
- `reset` - Reset all installed mods.
- `help` - Display this help message.
### Basic usage ### Basic usage
#### Install a mod To find out how to use a command, you can run `h2mm <COMMAND> --help`.
#### Install mod(s)
```bash ```bash
h2mm install /path/to/mod.zip h2mm install /path/to/mod.zip
h2mm install /path/to/mod/files h2mm install /path/to/mod/files
h2mm install /path/to/mod.zip /path/to/mod2.zip /path/to/mod/files
h2mm install -n "Example mod" mod.patch_0 mod.patch_0.stream # -n is mandatory when using files h2mm install -n "Example mod" mod.patch_0 mod.patch_0.stream # -n is mandatory when using files
h2mm install -n "Example mod" mod* # using a wildcard to include all files h2mm install -n "Example mod" mod* # using a wildcard to include all files
``` ```
> Currently, if the mod has more than 1 variant, you need to install the one you want by unarchiving it separately.
#### Uninstall a mod #### Uninstall a mod
```bash ```bash
h2mm uninstall "Example mod" h2mm uninstall -n "Example mod"
h2mm uninstall -i 1 # uninstall mod with index 1 h2mm uninstall -i 3
``` ```
#### Enable/disable mods #### Enable/disable mods
```bash ```bash
h2mm enable "Example mod" h2mm enable -n "Example mod"
h2mm enable -i 1 # enable mod with index 1 h2mm enable -i 3
h2mm disable "Example mod" h2mm disable -n "Example mod"
h2mm disable -i 1 # disable mod with index 1 h2mm disable -i 3
``` ```
#### List installed mods #### List installed mods
@@ -83,6 +87,24 @@ h2mm disable -i 1 # disable mod with index 1
h2mm list h2mm list
``` ```
#### Updating the script
```bash
h2mm update
```
## Compatibility
The script is developed and tested on Arch Linux, but it should work on other Linux distributions as well. If you encounter any issues, please open an issue on the repository.
Status of platforms:
- Linux :white_check_mark:
- Steam Deck :white_check_mark:
- Windows - WSL :white_check_mark:
> The script works on WSL, but you need to specify the path to the Helldivers 2 mods directory manually, to find your Windows partition head to `/mnt/` and from there go to your Helldivers 2 data directory, on a typical install it should be on `/mnt/c/Program\ Files\ \(x86\)/Steam/steamapps/common/Helldivers\ 2/data`. You also need to have `unzip` installed, which can be done by running `sudo apt install unzip`.
## Advanced usage ## Advanced usage
### Shortcuts ### Shortcuts
@@ -96,15 +118,34 @@ You can use the short form of commands to save some time. The shortcuts are:
- `l` for `list` - `l` for `list`
- `ex` for `export` - `ex` for `export`
- `im` for `import` - `im` for `import`
- `o` for `order`
- `mc` for `modpack-create`
- `ms` for `modpack-switch`
- `ml` for `modpack-list`
- `md` for `modpack-delete`
- `mo` for `modpack-overwrite`
- `mr` for `modpack-reset`
- `up` for `update`
- `r` for `reset` - `r` for `reset`
### Modpacks support
You can set up modpacks by using the `modpack-*` commands. This allows you to quickly change between a set of mods. For more information, check the help message.
```bash
h2mm modpack-create -n "Modpack 1"
# install, enable, disable other mods...
h2mm modpack-create -n "Modpack 2"
h2mm modpack-switch -n "Modpack 1"
```
### Exporting and importing ### Exporting and importing
You can export all installed mods to a zip file and import mods from the same file. This can be useful for sharing mods with others or for backing up your mods. The zip file will be saved in the current directory. You can export all installed mods to a zip file and import mods from the same file. This can be useful for sharing mods with others or for backing up your mods. The archive file (`.tar.gz`) will be saved in the current directory.
```bash ```bash
h2mm export modpack1.zip h2mm export
h2mm import modpack2.zip h2mm import /path/to/mods.tar.gz
``` ```
### Resetting all installed mods ### Resetting all installed mods
@@ -122,14 +163,3 @@ The database is stored in the `Helldivers 2` install directory, under the `data`
## Contributing ## Contributing
Feel free to contribute to this project by creating a pull request or opening an issue. Feel free to contribute to this project by creating a pull request or opening an issue.
## Planned features
- [x] Check for mod updates
- [x] Enable/disable mods
- [ ] Easier way to change mod presets
- [ ] Find a way to make use of `manifest.json` and simplify installing variants
- [x] [DEV] Change to `.tar.gz` for exporting and importing
- [x] [DEV] Provide fixes for breaking updates
- [ ] [DEV] Optimize code - throw errors in 1 line
- [ ] [DEV] Rewrite some code to be more readable
+1186 -401
View File
File diff suppressed because it is too large Load Diff
+135 -76
View File
@@ -1,4 +1,4 @@
#!/bin/bash #!/usr/bin/env bash
set -e set -e
RED='\033[0;31m' RED='\033[0;31m'
@@ -8,110 +8,169 @@ NC='\033[0m'
DESTINATION_PATH="/usr/local/bin" DESTINATION_PATH="/usr/local/bin"
SCRIPT_NAME="h2mm" SCRIPT_NAME="h2mm"
REPO_URL="https://raw.githubusercontent.com/v4n00/h2mm-cli/refs/heads/master"
if [ "$(id -u)" -eq 0 ]; then function log() {
echo "Run me as normal user, not as root." local type="$1"
exit 1 shift
fi case "$type" in
INFO)
echo -e "$*" >&2
;;
ERROR)
echo -e "${RED}[ERROR]${NC} $*" >&2
;;
PROMPT)
echo -ne "$*" >&2
;;
esac
}
# --- Main --- # --- Main ---
# Warning # warning
echo -e "!!! ${RED}WARNING${NC} !!!" cat << EOF
echo -e "This script will install Helldivers 2 Mod Manager CLI for Linux to $DESTINATION_PATH/$SCRIPT_NAME." !!! WARNING !!!
echo -e "Running this script will require sudo permissions. ${RED}DO NOT TRUST${NC} random scripts from the internet." This script will install Helldivers 2 Mod Manager CLI for Linux to $DESTINATION_PATH/$SCRIPT_NAME.
echo -e "If you want to review the script before running it, check out the mod repository for yourself:" Running this script will require sudo permissions. DO NOT TRUST random scripts from the internet.
echo -e "https://github.com/v4n00/h2mm-cli" If you want to review the script before running it, check out the mod repository for yourself:
echo -e "!!! ${RED}WARNING${NC} !!!" https://github.com/v4n00/h2mm-cli
echo !!! WARNING !!!
# Check if update EOF
# Breaking changes hash table
# breaking changes hash table
breaking_changes_patches=( breaking_changes_patches=(
["2"]='sed -i "s/^\([0-9]\+\),/\1,ENABLED,/" "$1/mods.csv"' ["2"]='sed -i "s/^\([0-9]\+\),/\1,ENABLED,/" "$1/mods.csv"'
["3"]='sed -i "1 i\\3" "$1/mods.csv"'
["4"]='awk '\''BEGIN {FS=OFS=","} NR==1 {print 4; next} {print NR-1, $2, $3, $4, $5}'\'' "$1/mods.csv" | tee "$1/mods.csv" > /dev/null'
) )
# Script # notify if update is happening
installed_version=""
latest_version=""
if [[ -x "$(command -v $SCRIPT_NAME)" ]]; then if [[ -x "$(command -v $SCRIPT_NAME)" ]]; then
installed_version=$($SCRIPT_NAME --version) installed_version=$($SCRIPT_NAME --version)
# version 1 show the help message, if the first character is not a 0, store installed version as 0.1.6
[[ ${installed_version:0:1} != "0" ]] && { installed_version="0.1.6"; }
latest_version=$(curl -sS https://raw.githubusercontent.com/v4n00/h2mm-cli/refs/heads/master/version) # if installed version isn't x.x.x crash
if [[ ! "$installed_version" =~ ^[0-9]+\.[0-9]+\.[0-9]+$ ]]; then
log ERROR "Installed version is not in the correct format."
log ERROR "h2mm is installed here -> $(which h2mm)"
log ERROR "Delete the script file and retry the install script, any mods installed will not be lost."
exit 1
fi
latest_version=$(curl -sS "$REPO_URL"/version)
if [[ "$latest_version" == "$installed_version" ]]; then if [[ "$latest_version" == "$installed_version" ]]; then
echo -e "You are reinstalling version $installed_version." log INFO "You are reinstalling version ${GREEN}$installed_version${NC}."
else else
echo -e "You are upgrading from ${ORANGE}$installed_version${NC} -> ${GREEN}$latest_version${NC}." log INFO "You are upgrading from ${ORANGE}$installed_version${NC} -> ${GREEN}$latest_version${NC}."
fi fi
fi
# split version numbers # if steam deck, set destination path to ~/.local/bin
installed_major="" log PROMPT "Are you installing on a Steam Deck? (y/N): "
latest_major="" IFS= read -e response_sd
IFS='.' read -r _1 installed_major _2 <<< "$installed_version"
IFS='.' read -r _1 latest_major _2 <<< "$latest_version"
if [[ $latest_major -gt $installed_major ]]; then if [[ "$response_sd" == "y" || "$response_sd" == "Y" ]]; then
echo -e "${ORANGE}Warning:${NC} Major version upgrade detected." # steam deck
echo "The script will proceed to upgrade ${SCRIPT_NAME} to avoid breaking changes." DESTINATION_PATH="$HOME/.local/bin"
mkdir -p "$DESTINATION_PATH"
# find hd2 path # check if ~/.local/bin is in PATH
search_dir="${HOME}" if [[ ":$PATH:" != *":$HOME/.local/bin:"* ]]; then
target_dir="Steam/steamapps/common/Helldivers\ 2/data" # add ~/.local/bin to PATH
echo "Searching for the Helldivers 2 data directory..." >&2 log INFO "Installing the script on a Steam Deck means adding $DESTINATION_PATH to your \$PATH."
game_dir=$(find "$search_dir" -type d -path "*/$target_dir" 2>/dev/null | head -n 1) log INFO "If you're using a different shell than bash, you may need to add it manually."
if [[ -z "$game_dir" ]]; then
echo "Could not find the Helldivers 2 data directory automatically." >&2
read -p "Please enter the path to the Helldivers 2 data directory: " game_dir
game_dir=$(eval echo "$game_dir")
if [[ ! -d "$game_dir" ]]; then log PROMPT "Do you want to add $DESTINATION_PATH to your \$PATH in ~/.bashrc? (Y/n): "
echo -e "${RED}Error${NC}: Provided path is not a valid directory." >&2 IFS= read -e response
exit 1 if [[ "$response" == "y" || "$response" = "Y" || -z "$response" ]]; then
fi echo "export PATH=\"\$HOME/.local/bin:\$PATH\"" >> "$HOME/.bashrc"
[[ $? -ne 0 ]] && { log ERROR "Failed to add $DESTINATION_PATH to \$PATH in ~/.bashrc." ; exit 1; }
log INFO "Added $DESTINATION_PATH to your \$PATH in ~/.bashrc."
fi fi
fi
else
# not steam deck
# set another path if needed
log PROMPT "Install the script to $DESTINATION_PATH or specify another path (must be included in \$PATH)? (Y/path): "
IFS= read -e response
[[ ! -f "$game_dir/mods.csv" ]] && { echo -e "${RED}Error:${NC} mods.csv not found in $game_dir."; exit 1; } if [[ "$response" != "y" && "$response" != "Y" && -n "$response" ]]; then
DESTINATION_PATH="$response"
# iterate from installed major number to latest major number [[ ! -d "$DESTINATION_PATH" ]] && { log ERROR "Path $DESTINATION_PATH does not exist." ; exit 1; }
for ((i = installed_major + 1; i <= latest_major; i++)); do
echo -e "${RED}[ ]${NC} Applying breaking changes patch for version $i."
[[ -n "${breaking_changes_patches[$i]}" ]] && eval $(echo "${breaking_changes_patches[$i]}" | sed "s:\$1:$game_dir:")
if [[ $? -ne 0 ]]; then
echo -ne "${RED}Error:${NC} Failed to apply breaking changes patch for version $i. Do you want to continue? (Y/n): "
read -r response
[[ "$response" != "y" && "$response" != "Y" && -n "$response" ]] && { echo "Exiting. Uninstall the script first the retry the install script."; exit 1; }
else
echo -e "${GREEN}[X]${NC} Breaking changes patch for version $i applied successfully."
fi
done
fi fi
fi fi
# Install # handle breaking changes
installed_major=$(echo "$installed_version" | awk -F. '{print $2}')
latest_major=$(echo "$latest_version" | awk -F. '{print $2}')
read -p "Install the script to $DESTINATION_PATH or specify another path (must be included in \$PATH)? (Y/path): " response if [[ $latest_major -gt $installed_major ]]; then
log INFO ""
log INFO "Major version upgrade detected."
log INFO "Check out the changelogs here -> https://github.com/v4n00/h2mm-cli/releases"
log INFO "The script will proceed to upgrade the database file to avoid breaking changes."
if [[ "$response" != "y" && "$response" != "Y" && -n "$response" ]]; then # find hd2 path
DESTINATION_PATH=$(eval echo "$response") search_dir="${HOME}"
if [[ ! -d "$DESTINATION_PATH" ]]; then target_dir="Steam/steamapps/common/Helldivers\ 2/data"
echo -e "${RED}Error:${NC} Path $DESTINATION_PATH does not exist. Exiting..."
exit 1 # check if game directory is in ~/.config/h2mm/h2path
fi if [[ -f "$HOME/.config/h2mm/h2path" ]]; then
game_dir=$(cat "$HOME/.config/h2mm/h2path")
[[ ! -d "$game_dir" ]] && { log ERROR "Helldivers 2 data directory in ~/.config/h2mm/h2path is not a valid directory." ; exit 1; }
log INFO "Helldivers 2 data directory found: $game_dir."
else
log INFO "Searching for the Helldivers 2 data directory... (20 seconds timeout)"
game_dir=$(timeout 20 find "$search_dir" -type d -path "*/$target_dir" 2>/dev/null | head -n 1)
fi
# if not found, prompt user
if [[ -z "$game_dir" ]]; then
log INFO "Could not find the Helldivers 2 data directory automatically."
log PROMPT "Please enter the path to the Helldivers 2 data directory: "
IFS= read -e game_dir
if [[ ! -d "$game_dir" ]]; then
log ERROR "Provided path is not a valid directory."
exit 1
fi
fi
[[ ! -f "$game_dir/mods.csv" ]] && { log ERROR "mods.csv not found in $game_dir." ; exit 1; }
# iterate from installed major number to latest major number
for ((i = installed_major + 1; i <= latest_major; i++)); do
if [[ -n "${breaking_changes_patches[$i]}" ]]; then
# apply breaking changes patch
eval $(echo "${breaking_changes_patches[$i]}" | sed "s:\$1:$game_dir:g")
else
log INFO "No breaking changes for version $i."
continue
fi
if [[ $? -ne 0 ]]; then
log ERROR "Failed to apply breaking changes patch for version $i. Do you want to continue? (Y/n): "
read -er response
[[ "$response" != "y" && "$response" != "Y" && -n "$response" ]] && { log INFO "Exiting." ; exit 1; }
else
log INFO "Version upgrade fix ${GREEN}successfully${NC} applied for version $i."
fi
done
log INFO ""
fi fi
echo "Installing $SCRIPT_NAME to $DESTINATION_PATH." # install
sudo curl https://raw.githubusercontent.com/v4n00/h2mm-cli/refs/heads/master/h2mm --output "$DESTINATION_PATH/$SCRIPT_NAME" log INFO "Installing $SCRIPT_NAME to $DESTINATION_PATH."
sudo curl "$REPO_URL"/h2mm --output "$DESTINATION_PATH/$SCRIPT_NAME"
sudo chmod +x "$DESTINATION_PATH/$SCRIPT_NAME" sudo chmod +x "$DESTINATION_PATH/$SCRIPT_NAME"
log INFO ""
if [[ ! -x "$(command -v $SCRIPT_NAME)" ]]; then [[ ! -x "$(command -v $SCRIPT_NAME)" ]] && { log ERROR "Installation failed. Mod manager was not found in \$PATH." ; exit 1; }
echo -e "${RED}Error:${NC} Installation failed." log INFO "Helldivers 2 Mod Manager CLI ${GREEN}successfully${NC} installed: $DESTINATION_PATH/$SCRIPT_NAME."
exit 1 log INFO "Use it by running '$SCRIPT_NAME'. Made with love <3 by v4n and contributors."
fi
echo "Helldivers 2 Mod Manager CLI installed successfully to $DESTINATION_PATH/$SCRIPT_NAME. Use it by running '$SCRIPT_NAME'."
+1 -1
View File
@@ -1 +1 @@
0.2.0 0.4.0